function PARA = surfaceCondition(GRID, PARA)   

% set surface parameters (albedo, emissivity, roughnesslength, resistance
% to evaporation) according to the actual surface conditions

% default soil surface 
PARA.surf.albedo  = PARA.soil.albedo;
PARA.surf.epsilon = PARA.soil.epsilon;
PARA.surf.z0      = PARA.soil.z0;
PARA.surf.rs      = PARA.soil.rs;
    
  
if GRID.snow.cT_domain(GRID.air.cT_domain_lb+1)==1 % snow surface
    PARA.surf.albedo  = PARA.snow.albedo;
    PARA.surf.epsilon = PARA.snow.epsilon;
    PARA.surf.z0      = PARA.snow.z0;
    PARA.surf.rs      = PARA.snow.rs;
end